<template>
  <div class="trendsCardPreview">
    <!-- Affichage du média -->
    <div v-if="attachmentExtension == 'image'" class="trendsCardPreviewMediaContainer">
      <img
        class="trendsCardMedia"
        :src="trend.attachment"
        alt="image choisie par l'utilisateur pour illustrer son post"
      />
    </div>

    <div v-if="attachmentExtension == 'audio'" class="trendsCardPreviewMediaContainer">
      <audio
        :src="trend.attachment"
        controls
        preload="none"
        class="trendsCardMedia"
      ></audio>
    </div>

    <div v-if="attachmentExtension == 'video'" class="trendsCardPreviewMediaContainer">
      <video :src="trend.attachment" controls class="trendsCardMedia"></video>
    </div>

    <!-- Affichage du texte -->
    <div class="trendsCardPreviewTextContainer">
      <h2>{{ trend.title }}</h2>
      <p>{{ trend.description }}</p>
      <p>Publié il y a {{ dateCreatedFromNow(trend.createdAt) }}</p>
    </div>
  </div>
</template>

<script>
import dayjs from "dayjs";
require("dayjs/locale/fr");
var relativeTime = require("dayjs/plugin/relativeTime");
dayjs.extend(relativeTime);
dayjs.locale("fr");

export default {
  name: "TrendsCard",
  props: {
    trend: Object,
  },
  computed: {
    attachmentExtension() {
      if (this.trend.attachment == null) {
        let extensionType = "";
        return extensionType;
      }

      let extension = this.trend.attachment.split(".")[1];
      let extensionType = "";
      switch (extension) {
        case "jpg":
          extensionType = "image";
          break;
        case "jpeg":
          extensionType = "image";
          break;
        case "png":
          extensionType = "image";
          break;
        case "avi":
          extensionType = "video";
          break;
        case "mp4":
          extensionType = "video";
          break;
        case "gif":
          extensionType = "gif";
          break;
        case "mp3":
          extensionType = "audio";
          break;
        default:
          null;
      }
      return extensionType;
    },
  },
  methods: {
    dateCreatedFromNow(date) {
      return dayjs(date).fromNow(true, "fr");
    },
  },
};
</script>

<style lang="scss" scoped>
.trendsCardPreview {
  width: 310px;
  height: 370px;
  padding: 15px;
  margin: 15px;
  border-radius: 25px;
  box-shadow: 10px 10px 10px #f2f2f2;
  margin-bottom: 15px;
  background-color: rgb(246, 242, 242);

  &MediaContainer {
    height: 70%;
  }
  &TextContainer {
    height: 30%;
    color: rgb(115, 13, 13);
  }
}
.trendsCardMedia {
  width: 100%;
  height: 100%;
  object-fit: cover;
  border-top-left-radius: 25px;
  border-top-right-radius: 25px;
}

h3 {
  color: black;
}
p {
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}
// -------- version portable

@media screen and (max-width: 66px) {
  .container {
    width: 500px;
  }
}
</style>
